<template>
  <div class="page-box" style="position: relative">
    <el-form
      ref="formTourHouseAreaMenuRef"
      :model="formData"
      :size="layoutStore.defaultFormItemSize"
      label-width="120px"
      label-position="right"
      @submit.prevent
    >
      <filter-box
        :item-width="350"
        @search="refreshFormTourHouseAreaMenu()"
        @reset="resetFormTourHouseAreaMenu"
      >
       <!-- <el-form-item label="菜单等级">
          <el-select
            class="filter-item"
            v-model="formFilter.levelNumFilter"
            placeholder=""
            :clearable="true"
            :filterable="true"
            @visible-change="levelNumFilterWidget.onVisibleChange"
          >
            <el-option
              v-for="item in levelNumFilterWidgetDropdownList"
              :key="item.id"
              :label="item.name"
              :value="item.id"
            />
          </el-select>
        </el-form-item> -->
        <el-form-item label="菜单名称">
          <el-input
            class="filter-item"
            v-model="formFilter.levelNameFilter"
            type="text"
            placeholder=""
            :clearable="true"
            :show-word-limit="false"
            maxlength=""
          />
        </el-form-item>
        <el-form-item label="是否启用">
          <el-select
            class="filter-item"
            v-model="formFilter.enableFilter"
            placeholder=""
            :clearable="true"
            :filterable="true"
            @visible-change="enableFilterWidget.onVisibleChange"
          >
            <el-option
              v-for="item in enableFilterWidgetDropdownList"
              :key="item.id"
              :label="item.name"
              :value="item.id"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="租售类型">
          <el-select
            class="filter-item"
            v-model="formFilter.typeFilter"
            placeholder=""
            :clearable="true"
            :filterable="true"
            @visible-change="typeFilterWidget.onVisibleChange"
          >
            <el-option
              v-for="item in typeFilterWidgetDropdownList"
              :key="item.id"
              :label="item.name"
              :value="item.id"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="是否热点">
          <el-select
            class="filter-item"
            v-model="formFilter.isHotspotFilter"
            placeholder=""
            :clearable="true"
            :filterable="true"
            @visible-change="isHotspotFilterWidget.onVisibleChange"
          >
            <el-option
              v-for="item in isHotspotFilterWidgetDropdownList"
              :key="item.id"
              :label="item.name"
              :value="item.id"
            />
          </el-select>
        </el-form-item>
      </filter-box>
    </el-form>
    <table-box
      ref="formTourHouseAreaMenuTable"
      class="page-table"
      :data="formTourHouseAreaMenuTableWidgetDataList"
      :size="layoutStore.defaultFormItemSize"
      :row-config="{ isCurrent: false, isHover: true }"
      :seq-config="{
        startIndex:
          (formTourHouseAreaMenuTableWidgetCurrentPage - 1) *
          formTourHouseAreaMenuTableWidgetPageSize,
      }"
      :sort-config="{ remote: true }"
      :hasExtend="true"
      @sort-change="formTourHouseAreaMenuTableWidget.onSortChange"
      @refresh="formTourHouseAreaMenuTableWidget.refreshTable()"
    >
      <template #operator>
        <el-button
          type="primary"
          :size="layoutStore.defaultFormItemSize"
          @click="onAddTourHouseAreaMenuClick()"
        >
          新建
        </el-button>
        <el-button
          type="primary"
          :size="layoutStore.defaultFormItemSize"
          @click="onExportTourHouseAreaMenuClick()"
        >
          导出
        </el-button>
        <el-upload
          class="btn-import"
          :auto-upload="false"
          action=""
          :show-file-list="false"
          accept=".xls,.xlsx"
          style="display: inline-block"
          :on-change="onImportTourHouseAreaMenuClick"
        >
          <template #trigger>
            <el-button type="primary" :size="layoutStore.defaultFormItemSize"> 导入 </el-button>
          </template>
        </el-upload>
      </template>
      <vxe-column
        title="序号"
        type="seq"
        :index="formTourHouseAreaMenuTableWidget.getTableIndex"
        :width="80"
      />
      <vxe-column title="父级区域" field="parentIdDictMap.name" />
      <vxe-column title="区域等级" field="levelNum" />
      <vxe-column title="区域名称" field="levelName" />
      <vxe-column title="显示顺序" field="showOrder" />
      <vxe-column title="是否热点" field="isHotspotDictMap.name" />
      <vxe-column title="是否启用" field="enableDictMap.name" />
      <vxe-column title="热门排序" field="hotOrder" />
      <vxe-column title="租售类型" field="typeDictMap.name" />
      <vxe-column title="操作" fixed="right">
        <template v-slot="scope">
          <el-button
            link
            type="primary"
            :size="layoutStore.defaultFormItemSize"
            @click.stop="onEditTourHouseAreaMenuClick(scope.row)"
          >
            编辑
          </el-button>
          <el-button
            link
            type="primary"
            :size="layoutStore.defaultFormItemSize"
            @click.stop="onDeleteTourHouseAreaMenuClick(scope.row)"
          >
            删除
          </el-button>
        </template>
      </vxe-column>
      <template v-slot:empty>
        <div class="table-empty unified-font">
          <img src="@/assets/img/empty.png" />
          <span>暂无数据</span>
        </div>
      </template>
      <!-- 分页 -->
      <template #pagination>
        <el-row type="flex" justify="end" style="margin-top: 10px">
          <el-pagination
            :total="formTourHouseAreaMenuTableWidgetTotalCount"
            :current-page="formTourHouseAreaMenuTableWidgetCurrentPage"
            :page-size="formTourHouseAreaMenuTableWidgetPageSize"
            :page-sizes="[10, 20, 50, 100]"
            layout="total, prev, pager, next, sizes"
            @current-change="formTourHouseAreaMenuTableWidget.onCurrentPageChange"
            @size-change="formTourHouseAreaMenuTableWidget.onPageSizeChange"
          >
          </el-pagination>
        </el-row>
      </template>
    </table-box>
    <label v-if="subPage" class="page-close-box" @click="onCancel()">
      <img src="@/assets/img/back2.png" alt="" />
    </label>
  </div>
</template>

<script lang="ts">
export default {
  name: 'formTourHouseAreaMenu',
};
</script>

<script setup lang="ts">
import { VxeColumn, VxeTable } from 'vxe-table';
import { ElMessage, ElMessageBox, UploadFile } from 'element-plus';
import { useRoute, useRouter } from 'vue-router';
import { ANY_OBJECT } from '@/types/generic';
import { DictData, DictionaryBase } from '@/common/staticDict/types';
import { useCommon } from '@/common/hooks/useCommon';
import { useLayoutStore, useStaticDictStore } from '@/store';
import { useDownload } from '@/common/hooks/useDownload';
import { useDropdown } from '@/common/hooks/useDropdown';
import { DropdownOptions, ListData } from '@/common/types/list';
import { useTable } from '@/common/hooks/useTable';
import { TableOptions } from '@/common/types/pagination';
import { useUpload } from '@/common/hooks/useUpload';
import { useUploadWidget } from '@/common/hooks/useUploadWidget';
import { DictionaryController } from '@/api/system';
import {
  treeDataTranslate,
  findItemFromList,
  findTreeNodePath,
  findTreeNode,
  stringCase,
} from '@/common/utils';
import { TourHouseAreaMenuData } from '@/api/generated/tourHouseAreaMenuController';
import { TourHouseAreaMenuController } from '@/api/generated';
import FormEditTourHouseAreaMenu from '@/pages/TourHouseAreaInfo/formEditTourHouseAreaMenu.vue';

const router = useRouter();
const route = useRoute();
const layoutStore = useLayoutStore();
const { downloadFile } = useDownload();
const { getUploadHeaders, getUploadActionUrl, fileListToJson, parseUploadData, getPictureList } =
  useUpload();
const {
  Delete,
  Search,
  Edit,
  Plus,
  Refresh,
  Picture,
  Dialog,
  mainContextHeight,
  clientHeight,
  checkPermCodeExist,
  parseParams,
  parseArrayParams,
  formatDateByStatsType,
  getDateRangeFilter,
} = useCommon();
// 静态字典
const { staticDict: StaticDict } = useStaticDictStore();

const props = withDefaults(
  defineProps<{
    subPage?: number | string | boolean;
  }>(),
  {
    subPage: 0,
  },
);

const formFilter = reactive({
  // 菜单等级
  levelNumFilter: undefined,
  // 菜单名称
  levelNameFilter: undefined,
  // 是否启用
  enableFilter: undefined,
  // 租售类型
  typeFilter: undefined,
  // 是否热点
  isHotspotFilter: undefined,
});
const formFilterCopy = reactive({
  // 菜单等级
  levelNumFilter: undefined,
  // 菜单名称
  levelNameFilter: undefined,
  // 是否启用
  enableFilter: undefined,
  // 租售类型
  typeFilter: undefined,
  // 是否热点
  isHotspotFilter: undefined,
});

const onCancel = () => {
  layoutStore.removeCachePage(route.name as string);
  route.meta.refreshParentCachedPage = true;
  router.go(-1);
};

const onResume = () => {
  refreshFormTourHouseAreaMenu();
};

/**
 * 表格组件数据获取函数，返回Promise
 */
const loadFormTourHouseAreaMenuTableWidgetData = (params: ANY_OBJECT) => {
  if (params == null) params = {};
  params = {
    ...params,
    tourHouseAreaMenuDtoFilter: {
      levelNum: formFilter.levelNumFilter,
      levelName: formFilter.levelNameFilter,
      enable: formFilter.enableFilter,
      type: formFilter.typeFilter,
      isHotspot: formFilter.isHotspotFilter,
    },
  };
  return new Promise((resolve, reject) => {
    TourHouseAreaMenuController.list(params)
      .then(res => {
        resolve({
          dataList: res.data.dataList,
          totalCount: res.data.totalCount,
        });
      })
      .catch(e => {
        reject(e);
      });
  });
};
/**
 * 表格组件数据获取检测函数，返回true正常获取数据，返回false停止获取数据
 */
const loadFormTourHouseAreaMenuTableVerify = () => {
  formFilterCopy.levelNumFilter = formFilter.levelNumFilter;
  formFilterCopy.levelNameFilter = formFilter.levelNameFilter;
  formFilterCopy.enableFilter = formFilter.enableFilter;
  formFilterCopy.typeFilter = formFilter.typeFilter;
  formFilterCopy.isHotspotFilter = formFilter.isHotspotFilter;
  return true;
};
/**
 * 新建
 */
const onAddTourHouseAreaMenuClick = (row?: TourHouseAreaMenuData) => {
  let params: ANY_OBJECT = {};

  Dialog.show('新建', FormEditTourHouseAreaMenu, { area: '900px' }, { ...params, subPage: true })
    .then(res => {
      formTourHouseAreaMenuTableWidget.refreshTable();
    })
    .catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
};
/**
 * 编辑
 */
const onEditTourHouseAreaMenuClick = (row?: TourHouseAreaMenuData) => {
  let params: ANY_OBJECT = {
    id: row?.id,
  };

  Dialog.show('编辑', FormEditTourHouseAreaMenu, { area: '900px' }, { ...params, subPage: true })
    .then(res => {
      formTourHouseAreaMenuTableWidget.refreshTable();
    })
    .catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
};
/**
 * 导出
 */
const onExportTourHouseAreaMenuClick = (row?: TourHouseAreaMenuData) => {
  let params: ANY_OBJECT = {};

  TourHouseAreaMenuController.export(params, '表格组件.xlsx')
    .then(res => {
      ElMessage.success('导出成功');
    })
    .catch(e => {
      ElMessage.error(e.errorMessage);
    });
};
/**
 * 导入
 */
const onImportTourHouseAreaMenuClick = file => {
  let params: ANY_OBJECT = {
    importFile: file.raw,
    // 是否忽略表头
    skipHeader: false,
  };

  TourHouseAreaMenuController.import(params)
    .then(res => {
      ElMessage.success('导入成功');
      formTourHouseAreaMenuTableWidget.refreshTable();
    })
    .catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
};
/**
 * 删除
 */
const onDeleteTourHouseAreaMenuClick = (row?: TourHouseAreaMenuData) => {
  let params: ANY_OBJECT = {
    id: row?.id,
  };

  ElMessageBox.confirm('是否删除此记录？')
    .then(res => {
      TourHouseAreaMenuController.delete(params)
        .then(res => {
          ElMessage.success('删除成功');
          formTourHouseAreaMenuTableWidget.refreshTable(false, 1);
        })
        .catch(e => {
          // TODO: 异常处理
          console.error(e);
        });
    })
    .catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
};
// 表格组件表格组件参数
const formTourHouseAreaMenuTableOptions: TableOptions<TourHouseAreaMenuData> = {
  loadTableData: loadFormTourHouseAreaMenuTableWidgetData,
  verifyTableParameter: loadFormTourHouseAreaMenuTableVerify,
  paged: true,
  rowSelection: false,
  orderFieldName: undefined,
  ascending: true,
};
// 表格组件表格组件
const formTourHouseAreaMenuTable = ref();
const formTourHouseAreaMenuTableWidget = useTable(formTourHouseAreaMenuTableOptions);
const {
  dataList: formTourHouseAreaMenuTableWidgetDataList,
  currentPage: formTourHouseAreaMenuTableWidgetCurrentPage,
  pageSize: formTourHouseAreaMenuTableWidgetPageSize,
  totalCount: formTourHouseAreaMenuTableWidgetTotalCount,
} = formTourHouseAreaMenuTableWidget;
/**
 * 菜单等级下拉数据获取函数
 */
const loadLevelNumFilterDropdownList = (): Promise<ListData<DictData>> => {
  return new Promise((resolve, reject) => {
    DictionaryController.dictGlobalDict({ dictCode: 'HouseAreaLevelNum', itemIdType: 'Integer' })
      .then(res => {
        resolve({
          dataList: res.getList(),
        });
      })
      .catch(e => {
        reject(e);
      });
  });
};
// 菜单等级配置参数
const levelNumFilterOptions: DropdownOptions<DictData> = {
  loadData: loadLevelNumFilterDropdownList,
  isTree: false,
};
// 菜单等级下拉组件
const levelNumFilterWidget = useDropdown(levelNumFilterOptions);
const { dropdownList: levelNumFilterWidgetDropdownList } = levelNumFilterWidget;
/**
 * 是否启用下拉数据获取函数
 */
const loadEnableFilterDropdownList = (): Promise<ListData<DictData>> => {
  return Promise.resolve({
    dataList: StaticDict.Enable.getList(),
  });
};
// 是否启用配置参数
const enableFilterOptions: DropdownOptions<DictData> = {
  loadData: loadEnableFilterDropdownList,
  isTree: false,
};
// 是否启用下拉组件
const enableFilterWidget = useDropdown(enableFilterOptions);
const { dropdownList: enableFilterWidgetDropdownList } = enableFilterWidget;
/**
 * 租售类型下拉数据获取函数
 */
const loadTypeFilterDropdownList = (): Promise<ListData<DictData>> => {
  return new Promise((resolve, reject) => {
    DictionaryController.dictGlobalDict({ dictCode: 'IsSaleOrRent', itemIdType: 'Integer' })
      .then(res => {
        resolve({
          dataList: res.getList(),
        });
      })
      .catch(e => {
        reject(e);
      });
  });
};
// 租售类型配置参数
const typeFilterOptions: DropdownOptions<DictData> = {
  loadData: loadTypeFilterDropdownList,
  isTree: false,
};
// 租售类型下拉组件
const typeFilterWidget = useDropdown(typeFilterOptions);
const { dropdownList: typeFilterWidgetDropdownList } = typeFilterWidget;
/**
 * 是否热点下拉数据获取函数
 */
const loadIsHotspotFilterDropdownList = (): Promise<ListData<DictData>> => {
  return Promise.resolve({
    dataList: StaticDict.Hotspot.getList(),
  });
};
// 是否热点配置参数
const isHotspotFilterOptions: DropdownOptions<DictData> = {
  loadData: loadIsHotspotFilterDropdownList,
  isTree: false,
};
// 是否热点下拉组件
const isHotspotFilterWidget = useDropdown(isHotspotFilterOptions);
const { dropdownList: isHotspotFilterWidgetDropdownList } = isHotspotFilterWidget;
const refreshFormTourHouseAreaMenu = () => {
  // 刷新段落
  formTourHouseAreaMenuTableWidget.refreshTable();
};
/**
 * 重置过滤值
 */
const resetFormTourHouseAreaMenu = () => {
  formFilter.levelNumFilter = undefined;
  formFilterCopy.levelNumFilter = undefined;
  formFilter.levelNameFilter = undefined;
  formFilterCopy.levelNameFilter = undefined;
  formFilter.enableFilter = undefined;
  formFilterCopy.enableFilter = undefined;
  formFilter.typeFilter = undefined;
  formFilterCopy.typeFilter = undefined;
  formFilter.isHotspotFilter = undefined;
  formFilterCopy.isHotspotFilter = undefined;
  refreshFormTourHouseAreaMenu();
};
/**
 * 重置所有过滤值
 */
const resetFilter = () => {
  resetFormTourHouseAreaMenu();
};
const formInit = () => {
  levelNumFilterWidget.onVisibleChange(true).catch(e => {
    console.error(e);
  });
  enableFilterWidget.onVisibleChange(true).catch(e => {
    console.error(e);
  });
  typeFilterWidget.onVisibleChange(true).catch(e => {
    console.error(e);
  });
  isHotspotFilterWidget.onVisibleChange(true).catch(e => {
    console.error(e);
  });
  refreshFormTourHouseAreaMenu();
};

onMounted(() => {
  formInit();
});
</script>
